/*
Given an array of integers A sorted in non-decreasing order, return an array of the squares of each number, also in sorted non-decreasing order.

 

Example 1:

Input: [-4,-1,0,3,10]
Output: [0,1,9,16,100]
Example 2:

Input: [-7,-3,2,3,11]
Output: [4,9,9,49,121]
 

Note:

1 <= A.length <= 10000
-10000 <= A[i] <= 10000
A is sorted in non-decreasing order.

*/

package main

import (
	"fmt"
	"math"
)

func main() {
	data := []int{-7,-3,2,3,11}
	fmt.Println(sortedSquares(data))
}

func sortedSquares(A []int) []int {
	result := make([]int, len(A))
	left, right, index := 0, len(A) - 1, len(A) - 1
	for left <= right {
		if math.Abs((float64)(A[right])) > math.Abs((float64)(A[left])) {
			result[index] = A[right] * A[right]
			right--
		} else {
			result[index] = A[left] * A[left]
			left++
		}
		index--
	}
	return result
}
